## dpkg 1.20.12+rpi1

=== tests/t-conffile-replaces-existing-and-upgrade/Makefile ===
TESTS_DEB := pkg-conff-original-0 pkg-conff-original-1 \
             pkg-conff-takeover-0 pkg-conff-takeover-1

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define CONFFILES
$(DPKG_QUERY) -f '$${Package} @ $${Conffiles}\n'
endef

define VERIFY
$(call pkg_is_installed,pkg-conff-original)
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
test "`$(CONFFILES) -W pkg-conff-original | grep obsolete | wc -l`" = "1"
test "`$(CONFFILES) -W pkg-conff-takeover | grep -v obsolete | wc -l`" = "1"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover-0.deb pkg-conff-original-1.deb
	$(DPKG_INSTALL) pkg-conff-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-clean:
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

=== tests/t-triggers/Makefile ===
TESTS_DEB := pkg-triggers pkg-triggers-await pkg-triggers-noawait \
             pkg-trig-file pkg-trig-explicit pkg-trig-cmd

include ../Test.mk

TEST_CASES += test-trigger-file
TEST_CASES += test-trigger-explicit
TEST_CASES += test-trigger-cmd
TEST_CASES += test-trigger-await-file
TEST_CASES += test-trigger-await-cmd
TEST_CASES += test-trigger-noawait-file
TEST_CASES += test-trigger-noawait-explicit
TEST_CASES += test-trigger-noawait-cmd
TEST_CASES += test-internal-db

test-case: $(TEST_CASES)

test-trigger-file test-trigger-await-file:
	if [ "$@" = "test-trigger-file" ]; then \
	  $(DPKG_UNPACK) pkg-triggers.deb; \
	else \
	  $(DPKG_UNPACK) pkg-triggers-await.deb; \
	fi
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, /triggers)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_is_installed,pkg-trig-file)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok unpacked)
	$(DPKG_CONFIGURE) pkg-trig-file
	# FIXME: Remove ifdef during dpkg 1.18.x cycle, after the apt
	# workaround has been reverted.
ifdef DPKG_HAS_CONFIGURE_WITH_IMPLICIT_TRIGGER_PENDING
	$(call pkg_status_is,pkg-trig-file,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
endif
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-file

test-trigger-noawait-file:
	$(DPKG_UNPACK) pkg-triggers-noawait.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, /triggers)
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_is_installed,pkg-trig-file)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-file)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-file.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-file,install ok unpacked)
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-file
	$(call pkg_is_installed,pkg-trig-file)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/triggers/ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/triggers/ok"
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-file

test-trigger-explicit:
	$(DPKG_UNPACK) pkg-triggers.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_is_installed,pkg-trig-explicit)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Try other ways to run the triggers
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only --pending
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(DPKG_CONFIGURE) pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Verify the trigger is activated on each status change
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited, pkg-triggers)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_status_is,pkg-trig-explicit,install ok triggers-awaited)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited, pkg-triggers)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_is_installed,pkg-triggers)
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-explicit

test-trigger-noawait-explicit:
	$(DPKG_INSTALL) pkg-triggers-noawait.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_is_installed,pkg-trig-explicit)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Again, but we're unpacking instead of installing
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# Verify the trigger is activated on each status change
	$(DPKG_UNPACK) --no-triggers pkg-trig-explicit.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_status_is,pkg-trig-explicit,install ok unpacked)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	test -f "$(DPKG_INSTDIR)/a-trigger-ok" && $(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-trig-explicit
	$(call pkg_is_installed,pkg-trig-explicit)
	$(call pkg_field_is,pkg-trig-explicit,Triggers-Awaited,)
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	# Cleanup
	$(DPKG_PURGE) pkg-triggers
	$(DPKG_PURGE) pkg-trig-explicit

test-trigger-cmd test-trigger-await-cmd:
	if [ "$@" = "test-trigger-await-cmd" ]; then \
	  $(BEROOT) touch "$(DPKG_INSTDIR)/trigger-await"; \
	fi
	$(DPKG_UNPACK) pkg-triggers.deb
	$(BEROOT) rm -f "$(DPKG_INSTDIR)/a-trigger-ok" "$(DPKG_INSTDIR)/triggers/ok"
	# When unpacked, triggers are not active
	$(BEROOT) touch "$(DPKG_INSTDIR)/trigger-postinst" "$(DPKG_INSTDIR)/trigger-preinst" "$(DPKG_INSTDIR)/trigger-postrm" "$(DPKG_INSTDIR)/trigger-prerm"
	$(DPKG_INSTALL) --no-triggers pkg-trig-cmd.deb
	$(call pkg_is_installed,pkg-trig-cmd)
	$(call pkg_status_is,pkg-triggers,install ok unpacked)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending,)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	$(DPKG_CONFIGURE) --no-triggers pkg-triggers
	$(call pkg_is_installed,pkg-triggers)
	! test -f "$(DPKG_INSTDIR)/a-trigger-ok"
	# When installed, triggers can be activated
	$(DPKG_INSTALL) --no-triggers pkg-trig-cmd.deb
	$(call pkg_status_is,pkg-triggers,install ok triggers-pending)
	$(call pkg_field_is,pkg-triggers,Triggers-Pending, a-trigger)
	$(call pkg_status_is,pkg-trig-cmd,install ok triggers-awaited)
	$(BEROOT) $(DPKG) --triggers-only pkg-triggers

=== debian/changelog ===
dpkg (1.20.12+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Tue, 13 Sep 2022 03:09:19 +0000

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.5.1
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
# Needed for ITS support.
 gettext (>= 0.19.7),
# Needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 zlib1g-dev,
 libbz2-dev,
 liblzma-dev,
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
# Needed for the functional test.
 bzip2 <!nocheck>,
 xz-utils <!nocheck>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 zlib1g-dev,
 liblzma-dev,
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
 xz-utils,
# Needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg,
 gpgv,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
 xz-utils,
Suggests:
 debian-keyring,
 gnupg,
 gpgv,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::Build::Info: build information functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	$(nil)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="hardening=+all" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/run-script scripts/dpkg-buildflags.pl

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Support cross-compiling.
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-silent-rules
	testflags += TESTSUITEFLAGS=--verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

D := $(CURDIR)/debian/tmp

# Configure the build tree
build-tree/config.status:
	dh_testdir
	dh_autoreconf

	install -d build-tree
	cd build-tree && ../configure $(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--prefix=/usr \
		--mandir=\$${datadir}/man \
		--infodir=\$${datadir}/info \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--localstatedir=/var \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--without-libmd \
		--with-libz \
		--with-liblzma \
		--with-libbz2

# Build the package in build-tree
build-indep build-arch build: build-tree/config.status
	dh_testdir

	cd build-tree && $(MAKE)

# Run the test suites
check: build
	dh_testdir

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#cd build-tree && $(MAKE) $(testflags) TEST_PARALLEL=$(NUMJOBS) check
endif

# Install the package underneath debian/tmp
install: check
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-tree && $(MAKE) DESTDIR=$(D) install

	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

define dpkg-installmanl10n
for f in `sed -e 's:\*:*/*:' -e 's:^:$(D)/:' debian/$(1).manpages`; do \
  if [ -e $$f ]; then \
    install -D $$f `echo $$f | sed -e 's:^$(D):debian/$(1):'`; \
  fi; \
done
endef

# Put together the dpkg and dselect packages
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_install -a
	dh_installcron -a
	dh_installlogrotate -a
	dh_installlogrotate -a --name=alternatives
	dh_installchangelogs -a ChangeLog*
	dh_installdocs -a
	$(call dpkg-installmanl10n,dpkg)
	$(call dpkg-installmanl10n,dselect)
	dh_installman -a
	dh_link -a
	dh_bugfiles -a -A
	dh_lintian -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

# Put together the dpkg-dev package
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_install -i
	dh_installcron -i
	dh_installchangelogs -i ChangeLog*
	dh_installdocs -i -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg
	$(call dpkg-installmanl10n,dpkg-dev)
	dh_installman -i
	dh_link -i
	dh_bugfiles -i -A
	dh_lintian -i
	dh_perl -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep


# Clean up the mess we made
clean:
	dh_testdir

	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build-tree
	dh_autoreconf_clean
	dh_clean


.PHONY: build check install binary-arch binary-indep binary clean

## dpkg 1.20.13

=== tests/t-conflicts/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	# test if the conflicting packages fail on install
	! $(DPKG_INSTALL) pkg-b.deb pkg-a.deb
	$(call pkg_is_not_installed,pkg-a)
	-$(DPKG_PURGE) pkg-a pkg-b
	! $(DPKG_INSTALL) pkg-a.deb pkg-b.deb
	$(call pkg_is_not_installed,pkg-b)
	-$(DPKG_PURGE) pkg-a pkg-b

test-clean:
	-$(DPKG_PURGE) pkg-a pkg-b

=== tests/t-control-bogus/Makefile ===
include ../Test.mk

test-case:
	# test building package with bogus control files
	! $(DPKG_BUILD_DEB) pkg-bogus-colon
	! $(DPKG_BUILD_DEB) pkg-bogus-blank
	! $(DPKG_BUILD_DEB) pkg-bogus-fieldname-empty
	! $(DPKG_BUILD_DEB) pkg-bogus-fieldname-partial
	! $(DPKG_BUILD_DEB) pkg-bogus-format-string
	
	# build bogus packages
	$(DPKG_BUILD_DEB) --nocheck pkg-bogus-colon
	$(DPKG_BUILD_DEB) --nocheck pkg-bogus-blank
	$(DPKG_BUILD_DEB) --nocheck pkg-bogus-fieldname-empty
	$(DPKG_BUILD_DEB) --nocheck pkg-bogus-fieldname-partial
	$(DPKG_BUILD_DEB) --nocheck pkg-bogus-format-string
	
	# test installing packages with bogus control files
	! $(DPKG_INSTALL) pkg-bogus-colon.deb
	$(call pkg_is_not_installed,pkg-bogus-colon)
	! $(DPKG_INSTALL) pkg-bogus-blank.deb
	$(call pkg_is_not_installed,pkg-bogus-blank)
	! $(DPKG_INSTALL) pkg-bogus-fieldname-empty.deb
	$(call pkg_is_not_installed,pkg-bogus-fieldname-empty)
	! $(DPKG_INSTALL) pkg-bogus-fieldname-partial.deb
	$(call pkg_is_not_installed,pkg-bogus-fieldname-partial)
	! $(DPKG_INSTALL) pkg-bogus-format-string.deb
	$(call pkg_is_not_installed,pkg-bogus-format-string)

test-clean:
	rm -f pkg-bogus-colon.deb
	rm -f pkg-bogus-blank.deb

=== tests/t-file-conflicts/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-a.deb
	# test if the conflicting package fails on install
	! $(DPKG_INSTALL) pkg-b.deb

test-clean:
	# tell dpkg we do not want pkg-b, even if we asked for it and failed
	echo pkg-b purge | $(BEROOT) $(DPKG) --set-selections
	-$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) pkg-a

=== tests/t-filtering/Makefile ===
TESTS_DEB := pkg-somefiles

include ../Test.mk

DEB_FILES_COUNT = $(shell dpkg-deb -c pkg-somefiles.deb | wc -l )

TEST_CASES += test-no-filter
TEST_CASES += test-no-doc-sub
TEST_CASES += test-no-doc-all
TEST_CASES += test-no-doc-except-copyright
TEST_CASES += test-no-doc-except-copyright-subdir
TEST_CASES += test-no-doc-except-copyright-and-readme
TEST_CASES += test-include-only
TEST_CASES += test-reinclude-subdir
TEST_CASES += test-same-include-exclude
TEST_CASES += test-upgrade test-help

test-case: $(TEST_CASES)

test-clean:
	$(DPKG_PURGE) pkg-somefiles

test-no-filter:
	# no filter, should have all files
	$(DPKG_INSTALL) pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	$(DPKG_PURGE) pkg-somefiles

test-no-doc-sub:
	# filter out /test/share/doc/*/*; this keeps the actual
	# /test/share/doc/pkg-somefiles dir around
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*/*' \
	  pkg-somefiles.deb
	test -d "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles"
	test "`ls '$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles'`" = ""
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-no-doc-all:
	# filter out /test/share/doc/*
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*' \
	  pkg-somefiles.deb
	! test -d "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-no-doc-except-copyright:
	# filter out /test/share/doc/*/* except copyright
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*/*' \
	  --path-include '/test/share/doc/*/copyright' \
	  pkg-somefiles.deb
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/README"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-no-doc-except-copyright-subdir:
	# prune the entire doc dir; this triggers the special case that
	# /test/share/doc/pkg-somefiles is matched by the exclude, but still
	# needs to be created due to the following include
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*' \
	  --path-include '/test/share/doc/*/copyright' \
	  pkg-somefiles.deb
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/README"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-no-doc-except-copyright-and-readme:
	# two includes which revert an exclude, second of which matches
	# several subdirs with one *
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*' \
	  --path-include '/test/share/doc/*/copyright' \
	  --path-include '/test*/READ*' \
	  pkg-somefiles.deb
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/README"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-include-only:
	# only includes, should be a no-op and have all files
	$(DPKG_INSTALL) \
	  --path-include '/test/*' \
	  --path-include '/test/share/doc' \
	  --path-include '/test/lib/*/*' \
	  pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-reinclude-subdir:
	# Exclude a directory tree and reinclude some of its subdirectories
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/locale/*' \
	  --path-include '/test/share/locale/de/*' \
	  pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -d "$(DPKG_INSTDIR)/test/share/locale/de"
	test -f "$(DPKG_INSTDIR)/test/share/locale/de/foo.mo"
	! test -f "$(DPKG_INSTDIR)/test/share/locale/ca/foo.mo"
	! test -f "$(DPKG_INSTDIR)/test/share/locale/es/foo.mo"
	$(DPKG_PURGE) pkg-somefiles

test-same-include-exclude:
	# include the same things than exclude, should be a no-op and have
	# all files
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/*' \
	  --path-include '/test/share/*' \
	  pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles
	
	# now doubly so
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/*' \
	  --path-include '/test/share/*' \
	  --path-exclude '/test/share/*' \
	  --path-include '/test/share/*' \
	  pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/html/index.html"
	test -f "$(DPKG_INSTDIR)/test/lib/pkg-somefiles/run"
	$(DPKG_PURGE) pkg-somefiles

test-upgrade:
	# files are removed/re-added on upgrades
	$(DPKG_INSTALL) pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*' \
	  pkg-somefiles.deb
	! test -d "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles"
	
	$(DPKG_INSTALL) \
	  --path-exclude '/test/share/doc/*' \
	  --path-include '/test/share/doc/*/copyright' \
	  pkg-somefiles.deb
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	! test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/README"
	
	$(DPKG_INSTALL) pkg-somefiles.deb
	test "`$(DPKG_QUERY) -L pkg-somefiles | wc -l`" = $(DEB_FILES_COUNT)
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/copyright"
	test -f "$(DPKG_INSTDIR)/test/share/doc/pkg-somefiles/README"
	$(DPKG_PURGE) pkg-somefiles

# --help output explains the options
test-help:
	$(DPKG) --help | grep -q -- --path-include
	$(DPKG) --help | grep -q -- --path-exclude

=== tests/t-switch-dir-to-symlink-abs/Makefile ===
TESTS_DEB := \
	pkg-dir-conffile-0 pkg-dir-conffile-1 \
	pkg-dir-file-other pkg-dir-symlink-int-0 pkg-dir-symlink-int-1 \
	pkg-dir-file-moved pkg-dir-symlink-ext-0 pkg-dir-symlink-ext-1

include ../Test.mk

build-hook:
	ln -sf test-dir pkg-dir-conffile-1/test-path
	ln -sf test-dir pkg-dir-symlink-ext-1/test-path
	ln -sf test-dir pkg-dir-symlink-int-1/test-path

clean-hook:
	$(RM) pkg-dir-conffile-1/test-path
	$(RM) pkg-dir-symlink-ext-1/test-path
	$(RM) pkg-dir-symlink-int-1/test-path

test-case:
	# Cannot switch a directory containing conffiles
	$(DPKG_INSTALL) pkg-dir-conffile-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! $(DPKG_INSTALL) pkg-dir-conffile-1.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_PURGE) pkg-dir-conffile

	# Cannot switch a directory containing files owned by another package
	$(DPKG_INSTALL) pkg-dir-file-other.deb
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! test -h '$(DPKG_INSTDIR)/test-path'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-file-other

	# Cannot switch a directory containing local files
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! test -h '$(DPKG_INSTDIR)/test-path'
	touch '$(DPKG_INSTDIR)/test-path/local file'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! test -h '$(DPKG_INSTDIR)/test-path'
	rm '$(DPKG_INSTDIR)/test-path/local file'
	$(DPKG_PURGE) pkg-dir-symlink-int

	#
	# Otherwise allow the switch
	#

	# Switch a directory to a symlink, contents moved within the package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	! test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path'

	# Switch a directory to a symlink, contents moved within the package,
	# with full install, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path'

	# Switch a directory to a symlink, contents moved within the package,
	# with two unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path'

	# Switch a directory to a symlink, contents moved to another package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-symlink-ext-1.deb
	test -h '$(DPKG_INSTDIR)/test-path'
	test "`readlink -f '$(DPKG_INSTDIR)/test-path'`" = "/test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with full installs, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path'
	test "`readlink -f '$(DPKG_INSTDIR)/test-path'`" = "/test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with three unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	$(DPKG_UNPACK) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path'
	test "`readlink -f '$(DPKG_INSTDIR)/test-path'`" = "/test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

test-clean:
	$(DPKG_PURGE) pkg-dir-conffile
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-other
	$(DPKG_PURGE) pkg-dir-file-moved

=== tests/t-switch-dir-to-symlink-rel/Makefile ===
TESTS_DEB := \
	pkg-dir-conffile-0 pkg-dir-conffile-1 \
	pkg-dir-file-other pkg-dir-symlink-int-0 pkg-dir-symlink-int-1 \
	pkg-dir-file-moved pkg-dir-symlink-ext-0 pkg-dir-symlink-ext-1

include ../Test.mk

build-hook:
	mkdir -p pkg-dir-conffile-1/test-path
	ln -sf ../test-dir pkg-dir-conffile-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-ext-1/test-path
	ln -sf ../test-dir pkg-dir-symlink-ext-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-int-1/test-path
	ln -sf ../test-dir pkg-dir-symlink-int-1/test-path/test-subpath

clean-hook:
	$(RM) pkg-dir-conffile-1/test-path/test-subpath
	-rmdir pkg-dir-conffile-1/test-path
	$(RM) pkg-dir-symlink-ext-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-ext-1/test-path
	$(RM) pkg-dir-symlink-int-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-int-1/test-path

test-case:
	# Cannot switch a directory containing conffiles
	$(DPKG_INSTALL) pkg-dir-conffile-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-conffile-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-conffile

	# Cannot switch a directory containing files owned by another package
	$(DPKG_INSTALL) pkg-dir-file-other.deb
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-file-other

	# Cannot switch a directory containing local files
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	touch '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	rm '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	$(DPKG_PURGE) pkg-dir-symlink-int

	#
	# Otherwise allow the switch
	#

	# Switch a directory to a symlink, contents moved within the package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with full install, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with two unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved to another package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-symlink-ext-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with full installs, upgrade with upack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with three unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

test-clean:
	$(DPKG_PURGE) pkg-dir-conffile
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-other
	$(DPKG_PURGE) pkg-dir-file-moved

=== debian/changelog ===
dpkg (1.20.13) bullseye; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Refactor pkg_format_print() out from pkg_format_show().
  * libdpkg: Handle missing Version when formatting source:Upstream-Version.
    Reported by John Scott <jscott@posteo.net>.
  * libdpkg: Fix varbuf memory leak in pkg_source_version().
  * Architecture support:
    - Add support for loong64 CPU.
      Based on a patch by 张丹丹 <zhangdandan@loongson.cn>. Closes: #1023486
  * Test suite:
    - Add new pkg-format unit tests.

 -- Guillem Jover <guillem@debian.org>  Wed, 13 Sep 2023 23:38:21 +0200

## dpkg 1.20.13pureos1.1

=== debian/changelog ===
dpkg (1.20.13pureos1.1) byzantium; urgency=medium

  * Reupload after `make dist`.

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 09:31:13 +0000

dpkg (1.20.13pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 07:07:52 +0100

dpkg (1.20.12pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 11 Jun 2023 10:38:34 +0200

dpkg (1.20.9pureos2) byzantium; urgency=medium

  * Makefile.am: Add debian/gbp.conf to EXTRA_DIST
  * Re-upload with package generated by `make dist` to
    fix build error on laniakea.
  * Remaining PureOS patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Wed, 14 Jul 2021 23:27:07 +0200

dpkg (1.20.9pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 09 Jul 2021 03:51:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: PureOS Maintainers <pureos-project@lists.puri.sm>
+XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
